Doomsday Engine - Bug #919

[Doom] Blast damage algorithm
2010-06-10 08:56 - gobhuo

Status: New Start date: 2010-06-10
Priority: Normal % Done: 0%
Assignee:

Category: Vanilla emulation

Target version: Vanilla / Gameplay

Description

Responding to your last comment in http://sourceforge.net/tracker/?func=detail&aid=2929822&group_id=74815&atid=542099 ;

| think that the new method is still incorrect, as it treats z-axis differently from x and y. In effect, to calculate damage, you calculate
distance from a blast to a "concentric” horisontal square. This violates the rule: if explosion happens on object's bounding box, it
deals full damage. | think you should use the distance from bounding box instead.

I just thought that arch-vile's attack damage could be incorrect because of this. And indeed: with "server-game-radiusattack-nomaxz
1" damage is usually 82 (practically correct), with "server-game-radiusattack-nomaxz 0" it's usually 78. In PrBoom+, v1.9
compatibility, it's 84. Tested on MAP11 @ doom2.wad, standing still.

Labels: Gameplay

History

#1 - 2010-06-06 19:02 - vermil

One should test in the original Doom2.exe and not PrBoom+ or any other source port.
#2 - 2010-06-11 10:38 - vermil

Indeed, I've just tested in Doom2.exe and Doom95 and got 83 every time.

Hence PrBoom+ 's 84 is wrong as well.

#3 - 2010-06-11 10:43 - danij

The world up axis is treated the same as the other axes it just depends on the value of server-game-radius-attack-nomaxz as to how many axes are
involved in the distance calculation.

Vanilla DOOM does it in 2D (same as server-game-radius-attack-nomaxz=1) whereas we do it in 3D by default.

Here is the actual code in question:

dx = fabs (thing->pos[VX] - bombSpot->pos|[VX]);

dy = fabs(thing->pos[VY] - bombSpot->pos[VY]) ;

dz = fabs((thing->pos[VZ] + thing->height / 2) - bombSpot->pos[VZ]);
dist = (dx > dy? dx : dy);

if (!cfg.netNoMaxZRadiusAttack) // "server—-game-radiusattack-nomaxz"
dist = (dz > dist? dz : dist);

dist = (dist - thing->radius);
The dist value is then fed into the damage equation:
damage = (bombDamage * (bombDistance - dist) / bombDistance) + 1;

#4 - 2010-07-20 19:34 - gobhuo

dx = fabs(thing->pos[VX] - bombSpot->pos[VX]);
dy = fabs(thing->pos[VY] - bombSpot->pos[VY]);

dist = (dx > dy? dx : dy);
dist = (dist - thing->radius);//subtract thing's radius here instead of in dx and dy expressions as an optimisation;
/Ihence it must precede z-related modification of dist.

dz = fabs((thing->pos[VZ] + thing->height / 2) - bombSpot->pos[VZ]) - thing->height / 2; /it was wrong here and in the location of dist = (dist -
thing->radius) expression
if(!cfg.netNoMaxZRadiusAttack) // "server-game-radiusattack-nomaxz"

dist = (dz > dist? dz : dist);

/[This should truly treat all axes the same.

#5 - 2010-07-20 21:07 - danij

| can see the radius subtraction is incorrectly placed but your other changes don't make sense to me.

#6 - 2010-07-20 21:37 - danij

Got it now, dunno why | didn't see it earlier.
...comment formatting here at sf is pretty awful however.

#7 - 2010-07-20 21:52 - skyjake
Anything happened to this?

#8 - 2012-03-02 12:01 - danij

Not as yet no, this still needs addressing.

#9 - 2013-10-22 19:44 - skyjake
- Tags set to PlaySim, Physics, Doom
- Category set to Vanilla emulation

- Target version deleted (1.9.0-beta6)

#10 - 2017-04-03 15:01 - skyjake

- Target version set to Modding

#11 - 2017-04-03 18:34 - skyjake

- Target version changed from Modding to Vanilla/ Gameplay
